local old_MessageEventHandler = ChatFrame_MessageEventHandler

-- Format: ["SYSTEM"] = { pattern1, pattern2, pattern3, ...}
local messagesToHide = {
	ERR_GUILD_INVITE_S,
	ERR_GUILD_DECLINE_S,
	ERR_ALREADY_IN_GUILD_S,
	ERR_ALREADY_INVITED_TO_GUILD_S,
	ERR_GUILD_DECLINE_AUTO_S,
	ERR_GUILD_PLAYER_NOT_FOUND_S,
}
local chatFilters = {}
local OnInt = {}

local function check(msg)
	local place
	local n
	local name
	for k,_ in pairs(messagesToHide) do
		place = strfind(messagesToHide[k],"%s",1,true)
		if place then
			name = strfind(msg," ",place,true)
			if name then
				n = strsub(msg,place,name-1)
				if format(messagesToHide[k],n) == msg then
					return true
				else
					n = strsub(msg,place,name-2)
					if format(messagesToHide[k],n) == msg then
						return true
					end
				end
			end
		end
	end
end

function ChatInterceptor(self,event,...)
	if ( strsub(event, 1, 8) == "CHAT_MSG" ) then
		local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15 = ...;
		local type = strsub(event, 10);
		local info = ChatTypeInfo[type];
		
		if check(arg1) then
			return
		end
		old_MessageEventHandler(self,event,...)
	end
end
	
ChatIntercept = {}

local old_ChatFrame_OnEvent = ChatFrame_OnEvent

function SGI_ChatFrame_OnEvent(self, event, ...)
	if ( ChatFrame_ConfigEventHandler(self, event, ...) ) then
		return;
	end
	if ( ChatFrame_SystemEventHandler(self, event, ...) ) then
		return
	end
	if ( ChatFrame_MessageEventHandler(self, event, ...) ) then
		return
	end
end

function ChatIntercept:State(on)
	if on then
		ChatFrame_MessageEventHandler = ChatInterceptor
		ChatFrame_OnEvent = SGI_ChatFrame_OnEvent
		print("|cffffff00ChatIntercept |r|cff00ff00Active|r")
	else
		ChatFrame_MessageEventHandler = old_MessageEventHandler
		ChatFrame_OnEvent = old_ChatFrame_OnEvent
		print("|cffffff00ChatIntercept |r|cffff0000Inactive|r")
	end
end
